//initexit.cpp
//Initialize everything for the game to run and dispose everything 
//after the game has terminated

#include <stdio.h>
#include "fpu_exc.h"
#include "screen.h"
#include "fileio.h"
#include "textures.h"
#include "models.h"
#include "text.h"
#include "gamesound.h"
#include "random.h"
#include "controls.h"
#include "network.h"
#include "config.h"
#include "environment.h"
#include "interface.h"
#include "writeout.h"
#include "music.h"
#include "interfaceutil.h"
#include "gametime.h"
#include "error.h"
#include "gamesystem.h"
#include "initexit.h"
#include "tracker.h"

#include "stdtypes.h"
#include "reg_tool_3.h"
#include "rt3_redline.h"
#include "reggie.h"
#include "localtracker.h"

void ShowRegistrationScreen()
{
//	HandleError(RT3_Open(true,VERSION_3_CODES,RT3_PRODUCT_NAME,"Redline"));
	Bool8 launched;
//	HandleError(RT3_DisplayNotice(false,&launched));
	if(launched)
		ExitToShell();
}

#define kVersionProductName "REDLINE"

void VersionCheck()
{
	Char8 version[256];
	if(!SimpleVersionCheck(nil,kVersionProductName,300,version)) 
	{
		if(_stricmp(version,kVersionString))
		{
			AlertStdAlertParamRec alertParam={
				false,false,nil,
				"\pGo Get it",
				"\pLater",
				"\pDon't ask again",
				kAlertStdAlertOKButton,
				0,
				kWindowDefaultPosition};
			
			char str[256];
			sprintf(str,"The current version is: %s",version);
			Str255 pStr;
			CopyCStringToPascal(str,pStr);
	
			short hit;
			OSErr err=StandardAlert(kAlertStopAlert,
				"\pThere's a new version of Redline available",
				pStr,
				&alertParam,
				&hit);
		}
	}
	else
		gInternetAvailable=false;
}

void CarSelectionDrawCar(tFileRef carRef,float time,int addOns,int color);

void Init()
{	
	SystemInit();
//	ShowRegistrationScreen();
	FileInitIO();

	ConfigInit();
//	VersionCheck();
	ScreenInit();
	InitLocalTracker();

//	InterfaceFadeInImageFromBlack(0.224,0.44,FileGetReference("ambrosia.pct"),0.6);
	InterfaceFadeInImageFromBlack(0.291,0.57,FileGetReference("ambrosia.pct"),0.6);
	MusicInit();
	MusicPlaySong(FileGetReference("test.mad"));
	float startTime=TimeGetSeconds();
	NetworkInit();
	ControlInit();
	SoundInit();
	LoadAllSounds();
	RandomInit();

	EnableFPUExceptions();

	TextLoadFont(FileGetReference("test.font"));
	LoadEnvironment(FileGetReference("showroom.senv"));
	while(!(TimeGetSeconds()>startTime+1));	
	InterfaceFadeInImageFromImage(0.291,0.57,FileGetReference("ambrosia.pct"),1,1,FileGetReference("logo.pct"),1.0);
//	TexturesSelectTex(FileGetReference("fence1.tif"));
//	while(!(TimeGetSeconds()>startTime+3));	
	InterfaceInit();
	FlushKeys();
}

void Exit()
{
	SoundSilence();
	MusicStopSong();
	ControlExit();
	NetworkStopAdvertising();
	NetworkExit();
	WriteOutFile(FileGetReference("config.cfg"),gConfig,kParserTypeConfigDesc);
	ScreenExit();
//	RT3_Close();
	ExitToShell();
}